
#ifndef __RENDERERFACTORY_H_
#define __RENDERERFACTORY_H_
/////////////////////////////
// Class: rendererFactory
// Description: This Factory object is solely responsible for the
//              proper creation of our rendererInterface object.
//              Rather than clutter up our main game code with
//              run-time DLL linking code, we can encapsulate all
//              of that into this object. 
//
/////////////////////////////
#include "rendererInterface.h"

class rendererFactory
{
private:
	rendererInterface	*m_pRenderer;

	HINSTANCE           m_hInst;
   	HMODULE             m_hDLL;

   public:
   	  rendererFactory(HINSTANCE hInst);
   	  ~rendererFactory();

   	  HRESULT initInterface(TCHAR *szType);
   	  rendererInterface* getInterface(){ return m_pRenderer; };
   	  void destroyInterface();
};

#endif